/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables.records;


import com.flamesgroup.storage.jooq.tables.ScriptParam;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record4;
import org.jooq.Row4;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ScriptParamRecord extends UpdatableRecordImpl<ScriptParamRecord> implements Record4<Long, Long, Long, byte[]> {

	private static final long serialVersionUID = 953736074;

	/**
	 * Setter for <code>public.script_param.id</code>.
	 */
	public ScriptParamRecord setId(Long value) {
		setValue(0, value);
		return this;
	}

	/**
	 * Getter for <code>public.script_param.id</code>.
	 */
	public Long getId() {
		return (Long) getValue(0);
	}

	/**
	 * Setter for <code>public.script_param.script_instance_id</code>.
	 */
	public ScriptParamRecord setScriptInstanceId(Long value) {
		setValue(1, value);
		return this;
	}

	/**
	 * Getter for <code>public.script_param.script_instance_id</code>.
	 */
	public Long getScriptInstanceId() {
		return (Long) getValue(1);
	}

	/**
	 * Setter for <code>public.script_param.script_param_def_id</code>.
	 */
	public ScriptParamRecord setScriptParamDefId(Long value) {
		setValue(2, value);
		return this;
	}

	/**
	 * Getter for <code>public.script_param.script_param_def_id</code>.
	 */
	public Long getScriptParamDefId() {
		return (Long) getValue(2);
	}

	/**
	 * Setter for <code>public.script_param.value</code>.
	 */
	public ScriptParamRecord setValue(byte[] value) {
		setValue(3, value);
		return this;
	}

	/**
	 * Getter for <code>public.script_param.value</code>.
	 */
	public byte[] getValue() {
		return (byte[]) getValue(3);
	}

	// -------------------------------------------------------------------------
	// Primary key information
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Record1<Long> key() {
		return (Record1) super.key();
	}

	// -------------------------------------------------------------------------
	// Record4 type implementation
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row4<Long, Long, Long, byte[]> fieldsRow() {
		return (Row4) super.fieldsRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row4<Long, Long, Long, byte[]> valuesRow() {
		return (Row4) super.valuesRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Long> field1() {
		return ScriptParam.SCRIPT_PARAM.ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Long> field2() {
		return ScriptParam.SCRIPT_PARAM.SCRIPT_INSTANCE_ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Long> field3() {
		return ScriptParam.SCRIPT_PARAM.SCRIPT_PARAM_DEF_ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<byte[]> field4() {
		return ScriptParam.SCRIPT_PARAM.VALUE;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Long value1() {
		return getId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Long value2() {
		return getScriptInstanceId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Long value3() {
		return getScriptParamDefId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public byte[] value4() {
		return getValue();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamRecord value1(Long value) {
		setId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamRecord value2(Long value) {
		setScriptInstanceId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamRecord value3(Long value) {
		setScriptParamDefId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamRecord value4(byte[] value) {
		setValue(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamRecord values(Long value1, Long value2, Long value3, byte[] value4) {
		value1(value1);
		value2(value2);
		value3(value3);
		value4(value4);
		return this;
	}

	// -------------------------------------------------------------------------
	// Constructors
	// -------------------------------------------------------------------------

	/**
	 * Create a detached ScriptParamRecord
	 */
	public ScriptParamRecord() {
		super(ScriptParam.SCRIPT_PARAM);
	}

	/**
	 * Create a detached, initialised ScriptParamRecord
	 */
	public ScriptParamRecord(Long id, Long scriptInstanceId, Long scriptParamDefId, byte[] value) {
		super(ScriptParam.SCRIPT_PARAM);

		setValue(0, id);
		setValue(1, scriptInstanceId);
		setValue(2, scriptParamDefId);
		setValue(3, value);
	}
}
